package org.xdoclet.plugin.castor.qtags;

public class CastorClassTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.castor.qtags.CastorClassTag {
    public static final String NAME = "castor.class";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"depends",
		"extends",
		"auto-complete",
		"identity",
		"access",
		"key-generator",
		"description",
		"table",
		"xml",
		"ns-uri",
		"ns-prefix",
		"ldap-dn",
		"ldap-oc",
		"cache-type",
		"cache-capacity",
		"verify-constructable",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public CastorClassTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public CastorClassTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getDepends() {
		boolean required = false;
        String result = getNamedParameter("depends");
        if(required && result == null) {
            bomb("depends=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getExtends() {
		boolean required = false;
        String result = getNamedParameter("extends");
        if(required && result == null) {
            bomb("extends=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isAutoComplete() {
		boolean required = false;
        String result = getNamedParameter("auto-complete");
        if(required && result == null) {
            bomb("auto-complete=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "true";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String getIdentity() {
		boolean required = false;
        String result = getNamedParameter("identity");
        if(required && result == null) {
            bomb("identity=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAccess() {
		boolean required = false;
        String result = getNamedParameter("access");
        if(required && result == null) {
            bomb("access=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "shared";
        }

		if (result != null) {
	            if( !(false || result.equals("read-only")|| result.equals("shared")|| result.equals("exclusive")|| result.equals("db-locked")) ) {
	                // todo we should say what file and line number too
	                bomb("access=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getKeyGenerator() {
		boolean required = false;
        String result = getNamedParameter("key-generator");
        if(required && result == null) {
            bomb("key-generator=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDescription() {
		boolean required = false;
        String result = getNamedParameter("description");
        if(required && result == null) {
            bomb("description=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTable() {
		boolean required = false;
        String result = getNamedParameter("table");
        if(required && result == null) {
            bomb("table=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getXml() {
		boolean required = false;
        String result = getNamedParameter("xml");
        if(required && result == null) {
            bomb("xml=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNsUri() {
		boolean required = false;
        String result = getNamedParameter("ns-uri");
        if(required && result == null) {
            bomb("ns-uri=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNsPrefix() {
		boolean required = false;
        String result = getNamedParameter("ns-prefix");
        if(required && result == null) {
            bomb("ns-prefix=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLdapDn() {
		boolean required = false;
        String result = getNamedParameter("ldap-dn");
        if(required && result == null) {
            bomb("ldap-dn=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLdapOc() {
		boolean required = false;
        String result = getNamedParameter("ldap-oc");
        if(required && result == null) {
            bomb("ldap-oc=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCacheType() {
		boolean required = false;
        String result = getNamedParameter("cache-type");
        if(required && result == null) {
            bomb("cache-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "count-limited";
        }

		if (result != null) {
	            if( !(false || result.equals("none")|| result.equals("count-limited")|| result.equals("time-limited")|| result.equals("unlimited")) ) {
	                // todo we should say what file and line number too
	                bomb("cache-type=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public int getCacheCapacity() {
		boolean required = false;
        String result = getNamedParameter("cache-capacity");
        if(required && result == null) {
            bomb("cache-capacity=\"???\" must be specified.");
        }

		int retVal = 0;


		if (result != null) {
		        try {
	                retVal = Integer.decode(result).intValue();
	            } catch(NumberFormatException nfe) {
	                bomb("cache-capacity=\"" + result + "\" is not valid integer");
	                throw nfe;
	            }
		}
		
		return retVal;
    }
    public boolean isVerifyConstructable() {
		boolean required = false;
        String result = getNamedParameter("verify-constructable");
        if(required && result == null) {
            bomb("verify-constructable=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "true";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getDepends();
        getExtends();
        isAutoComplete();
        getIdentity();
        getAccess();
        getKeyGenerator();
        getDescription();
        getTable();
        getXml();
        getNsUri();
        getNsPrefix();
        getLdapDn();
        getLdapOc();
        getCacheType();
        getCacheCapacity();
        isVerifyConstructable();
    }

    public void validateModel() {
        // check uniqueness
        if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}