package org.xdoclet.plugin.castor.qtags;

public class CastorFieldSqlTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.castor.qtags.CastorFieldSqlTag {
    public static final String NAME = "castor.field-sql";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"name",
		"type",
		"many-key",
		"many-table",
		"read-only",
		"dirty",
		"transient",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public CastorFieldSqlTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public CastorFieldSqlTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getName_() {
		boolean required = false;
        String result = getNamedParameter("name");
        if(required && result == null) {
            bomb("name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getType() {
		boolean required = false;
        String result = getNamedParameter("type");
        if(required && result == null) {
            bomb("type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getManyKey() {
		boolean required = false;
        String result = getNamedParameter("many-key");
        if(required && result == null) {
            bomb("many-key=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getManyTable() {
		boolean required = false;
        String result = getNamedParameter("many-table");
        if(required && result == null) {
            bomb("many-table=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isReadOnly() {
		boolean required = false;
        String result = getNamedParameter("read-only");
        if(required && result == null) {
            bomb("read-only=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String getDirty() {
		boolean required = false;
        String result = getNamedParameter("dirty");
        if(required && result == null) {
            bomb("dirty=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "check";
        }

		if (result != null) {
	            if( !(false || result.equals("check")|| result.equals("ignore")) ) {
	                // todo we should say what file and line number too
	                bomb("dirty=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isTransient() {
		boolean required = false;
        String result = getNamedParameter("transient");
        if(required && result == null) {
            bomb("transient=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnClass) {
        	bomb("is not allowed on classes");
		}
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getName_();
        getType();
        getManyKey();
        getManyTable();
        isReadOnly();
        getDirty();
        isTransient();
    }

    public void validateModel() {
        // check uniqueness
        if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}