package org.xdoclet.plugin.castor.qtags;

public class CastorFieldTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.castor.qtags.CastorFieldTag {
    public static final String NAME = "castor.field";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"type",
		"required",
		"direct",
		"lazy",
		"transient",
		"handler",
		"set-method",
		"get-method",
		"create-method",
		"collection",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public CastorFieldTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public CastorFieldTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getType() {
		boolean required = false;
        String result = getNamedParameter("type");
        if(required && result == null) {
            bomb("type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isRequired() {
		boolean required = false;
        String result = getNamedParameter("required");
        if(required && result == null) {
            bomb("required=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "true";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean isDirect() {
		boolean required = false;
        String result = getNamedParameter("direct");
        if(required && result == null) {
            bomb("direct=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "false";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean isLazy() {
		boolean required = false;
        String result = getNamedParameter("lazy");
        if(required && result == null) {
            bomb("lazy=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "true";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean isTransient() {
		boolean required = false;
        String result = getNamedParameter("transient");
        if(required && result == null) {
            bomb("transient=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "false";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String getHandler() {
		boolean required = false;
        String result = getNamedParameter("handler");
        if(required && result == null) {
            bomb("handler=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSetMethod() {
		boolean required = false;
        String result = getNamedParameter("set-method");
        if(required && result == null) {
            bomb("set-method=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getGetMethod() {
		boolean required = false;
        String result = getNamedParameter("get-method");
        if(required && result == null) {
            bomb("get-method=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCreateMethod() {
		boolean required = false;
        String result = getNamedParameter("create-method");
        if(required && result == null) {
            bomb("create-method=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCollection() {
		boolean required = false;
        String result = getNamedParameter("collection");
        if(required && result == null) {
            bomb("collection=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "vector";
        }

		if (result != null) {
	            if( !(false || result.equals("array")|| result.equals("arraylist")|| result.equals("vector")|| result.equals("hashtable")|| result.equals("collection")|| result.equals("set")|| result.equals("map")) ) {
	                // todo we should say what file and line number too
	                bomb("collection=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnClass) {
        	bomb("is not allowed on classes");
		}
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getType();
        isRequired();
        isDirect();
        isLazy();
        isTransient();
        getHandler();
        getSetMethod();
        getGetMethod();
        getCreateMethod();
        getCollection();
    }

    public void validateModel() {
        // check uniqueness
        if(((com.thoughtworks.qdox.model.AbstractJavaEntity)getContext()).getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}